{-----------------------------------------------------------------------------}
{ Label handling inside compiler/lister.                         (c) 1992 YGP }

    procedure def_forward(fidp: idp; var fid: identifier);
      var wp: pointer; welst: ex_lstp; wid: identifier;  {$ifdef id_correction}
	  lname: ident_str;					       {$endif}
    begin { def_forward }
          {         expression-    }
          {   expression-   .      }
          {     label     . }

      fid.id_flags:= fid.id_flags or fidp^.id_flags;
      welst:= fidp^.elst; fidp^.elst:= nil;

                                                         {$ifdef id_correction}
      if l_flags and _l_pass = 0 then begin
        get_idname(fidp, lname);
        writeln;
        writeln('correcting label ', lname);
      end { if };
                                                                       {$endif}
      change_lab(fidp, fid);                             {   }
      while welst <> nil do begin                   {    }
                                                         {$ifdef id_correction}
        (*)
        if l_flags and _l_pass = 0 then begin
          write('this: ', swap(word(welst^.expr)), ', next: ');
          if welst^.next = nil then
            write('none')
          else begin
            write(swap(word(welst^.next^.expr)));
          end { if };
          write(' >');
        end { if };
        (*)                                                            {$endif}

	wp:= check_expression(welst^.expr, fidp, addr(fid), wid);
        if wp <> nil then begin    {       }
          def_forward(wp, wid);
	end { if };
	wp:= welst; welst:= welst^.next;                           { get next }
	(* ) writeln; writeln('pointer to dispose: ', swap(wp)); ( *)
	(*) freememwords(wp, wordsizeof(welst^));
	{*) freemem(wp, sizeof(welst^));           { and free mem for current }
      end { while };
                                                         {$ifdef id_correction}
      if l_flags and _l_pass = 0 then begin
        writeln('label ', lname, ' corrected!');
      end { if };                                                      {$endif}
    end { def_forward };

    procedure define_label((*)const{*)var{*} apc:   apc_rec;
		 {$ifdef change_psize} var {$endif} psize: shortcard;
                           (*)const{*)var{*} pname: packed_name);
      var lidp: idp; wid: identifier;
    begin { define label LAB_NAME (pname, psize) at address _APC }

      {$ifdef change_psize}
      if psize <> 0 then {$endif} begin     {       }
        with wid do begin
	  if apc._mod = 0 then begin        {  ,  0..65535 }
	    id_type:= id_word; wval:= apc.pc; id_flags:= 0;
	    (*
            if apc.pc < 256 then begin
              id_type:= id_byte; bval:= apc.pc; end
            else begin
              id_type:= id_word; wval:= apc.pc;
	    end { if };
	    *) end
	  else if (c_flags and (_c_section +
				_c_obj_file+ _c_pgm_file+
				_c_bin_file+ _c_cmd_file) = 0) then
	    error(e_fkind)                        {       }
	  else begin
            unimplemented('not absolute address');
          end { if };
	end { with };

     (*      equ -> *)
        lidp:= find_lab(psize, pname);              {     ident }
        if lidp = nil then begin
          if local_label and (lvl <> nil) then
            lidp:= insert_lab(psize, pname, wid, lvl^.labs)
          else begin
            lidp:= insert_lab(psize, pname, wid, global_labs)
          end { if }; end
        else if (lidp^.id_type > id_forward) or
                local_label and (flvl <> lvl) then begin

          unpack_ident(psize, pname, idnm); err_sy:= ident; error(e_redef); end
	else begin                                   { forward declared label }
	  if not local_label then wid.id_flags:= wid.id_flags or _i_global;
          def_forward(lidp, wid);             { define forward declared label }
        end { if };
     (* <-         equ *)
	{$ifdef change_psize}
	psize:= 0;       {   ,       }
	{$endif}
      end { if };
    end { define_label };

{-----------------------------------------------------------------------------}